import org.garret.jipc.*;

/**
 * Test for events with automatic reset.
 * Usage:
 * Start N processes with IDs 0,1,..N-1:
 *    java Baton 3 0
 *    java Baton 3 1
 *    java Baton 3 2
 * Output: none
 */
public class Baton extends JIPCTest { 
    static final int nIterations = 1000;
  
    public static void main(String args[]) throws Exception { 
	JIPCSession session = createSession();
	if (args.length < 2) { 
	    System.out.println("Usage: java Baton <number-of-participants> <id>");
	    return;
	}
	int nParticipants = Integer.parseInt(args[0], 10);	
	int id = Integer.parseInt(args[1], 10);	
	JIPCEvent event[] = new JIPCEvent[nParticipants];
	for (int i = 0; i < nParticipants; i++) { 
	    event[i] = session.createEvent("event" + i, i == 0, false);
	}
	for (int i = 0; i < nIterations; i++) { 
	    event[id].waitFor();
	    event[(id+1) % nParticipants].signal();
	}
	session.close();
    }
}
