import org.garret.jipc.*;

/**
 * Test for semaphores and events with manual reset
 * Usage: 
 * 1. Start arbiter by "java Race N" command, where N is number of race participants
 * 2. Start N processes by "java Race" command
 * Ouput: none
 */
public class Race extends JIPCTest { 
    static final int nIterations = 1000;
  
    public static void main(String args[]) throws Exception { 
	JIPCSession session = createSession();
	JIPCEvent start = session.createEvent("start", false, true);
	JIPCEvent finish = session.createEvent("finish", false, true);
	JIPCEvent temp;
	JIPCSemaphore semaphore = session.createSemaphore("race", 0);

	if (args.length == 1 || (args.length == 2 && args[1].equals("0"))) { 
	    int nParticipants = Integer.parseInt(args[0], 10);
	    if (args.length == 2) {
		nParticipants -= 1;
	    }
	    for (int i = 0; i < nIterations; i++) { 
		start.signal();
		for (int j = 0; j < nParticipants; j++) { 
		    semaphore.waitFor();
		}
		start.reset();
		temp = start; start = finish; finish = temp;
	    }
	} else { 
	    for (int i = 0; i < nIterations; i++) { 
		start.waitFor();
		semaphore.signal();
		temp = start; start = finish; finish = temp;
	    }
	}
	start.close();
	finish.close();
	semaphore.close();

	session.close();
    }
}
